import { IList } from './list.interface';
import { ICompute, IMapList, IPredicate, ManyOrUndefinedOrNullOr, UndefinedOrNullOr } from '../types';
export declare abstract class ACommonList<listType extends IList<T>, T> extends Array<T> implements IList<T> {
    protected constructor(items?: ManyOrUndefinedOrNullOr<T>);
    thisAsT(): listType;
    abstract create(list?: listType): listType;
    abstract createSimpleList<U>(): IList<U>;
    clone(): listType;
    getItems(): T[];
    removeAll(): void;
    size(): number;
    isEmpty(): boolean;
    hasEntries(): boolean;
    set(items: ManyOrUndefinedOrNullOr<T>): listType;
    add(items: ManyOrUndefinedOrNullOr<T>): listType;
    addIf(items: ManyOrUndefinedOrNullOr<T>, filterFn: IPredicate<T>): listType;
    addIfAbsent(items: ManyOrUndefinedOrNullOr<T>): listType;
    remove(items: ManyOrUndefinedOrNullOr<T>): listType;
    removeIf(items: ManyOrUndefinedOrNullOr<T>, filterFn: IPredicate<T>): listType;
    removeIfPresent(items: ManyOrUndefinedOrNullOr<T>): listType;
    containsDuplicates(): boolean;
    containsAny(item: UndefinedOrNullOr<T>): boolean;
    containsNone(item: UndefinedOrNullOr<T>): boolean;
    map<mappedType>(callbackFn: IMapList<T, mappedType>): IList<mappedType>;
    pluck<keyType extends keyof T>(key: keyType): IList<T[keyType]>;
    forEachIf(callbackFn: ICompute<T>, filterFn: IPredicate<T>): listType;
    computeIfPresent(items: ManyOrUndefinedOrNullOr<T>, callbackFn: ICompute<T>): listType;
    computeIfAbsent(items: ManyOrUndefinedOrNullOr<T>, callbackFn: ICompute<T>): listType;
    private computeIf;
    shuffle(): listType;
}
//# sourceMappingURL=list.abstract.d.ts.map